#ifndef MEMORYMANAGER_H
#define MEMORYMANAGER_H
#include "memorymanager.h"
#endif // MEMORYMANAGER_H


#ifndef SIGLOWPAN_H
#define SIGLOWPAN_H

#include <Ieee154.h>

#include "mymsp430.h"
#include "UDP.h"
#include "ICMPv6.h"
#include "IPv6.h"
#include "IPv6RoutingTable.h"
#include "IPv6.c"
#include "checksum.c"
#include "RFC4944.h"
#include "RFC6282.h"
#include "6LoWPAN.h"
#include "IPv6over154.h"
#include "RFC6282.c"
#include "RFC4944.c"


#ifdef SLP_IPV6_ASCII_PARSING
#define TO_CHAR(X) (((X) < 10) ? ('0' + (X)) : ('a' + ((X) - 10)))
#define CHAR_VAL(X)  (((X) >= '0' && (X) <= '9') ? ((X) - '0') : \
                      (((X) >= 'A' && (X) <= 'F') ? ((X) - 'A' + 10) : ((X) - 'a' + 10)))
                      
/*
 * Adaptation of inet_pton6 function available in TinyOS
 * support/sdk/c/blip/lib6lowpan/utility.c
 */

void slp_string2address(char *addr, slp_ip6_addr_t *dest) {
  uint16_t cur = 0;
  uint16_t tt;
  uint8_t shift;
  char *p = addr;
  char* stop;
  void* temp = dest;
  if (addr == NULL || dest == NULL) return;
  memset(dest, 0, 16);

  // first fill in from the front
	while (*p != '\0') {
		if (*p != ':') {
			cur <<= 4;
			cur |= CHAR_VAL(*p);
		} 
		else {
			cur = htons(cur);
			memcpy (temp, &cur, 2);
			temp += 2;
			cur = 0;
		}
		p++;
		if (*p == '\0') {
			cur = htons(cur);
			memcpy (temp, &cur, 2);
			temp += 2;
			return;
		}
		if (*(p - 1) == ':' && *p == ':') {
			break;
		}
	}
	stop = p-1;
// we must have hit a "::" which means we need to start filling in from the end.
	temp = dest;
	temp += 14;
	shift = 0;
	tt = 0;
	while (*p != '\0') 
		p++;
	p--;
	// now pointing at the end of the address string
	while (p > stop) {
	if (*p != ':') {
		tt = (CHAR_VAL(*p) << shift);
		shift += 4;
		cur += tt;
	} else {
		cur = htons (cur);
		memcpy (temp, &cur, 2);
		temp -= 2;
		cur = 0; 
		shift = 0;
	}
	p --;
	if (*(p + 1) == ':' && *p == ':') break;
	}
}
#endif

#endif // SIGLOWPAN_H



