/* Copyright (c) 2009 The Regents of the Signet Group.
*  All rights reserved.
*
*  Permission to use, copy, modify, and distribute this software and its
*  documentation for any purpose, without fee, and without written
*  agreement is hereby granted, provided that the above copyright
*  notice, the (updated) modification history and the author appear in
*  all copies of this source code.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS `AS IS'
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS
*  BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
*  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, LOSS OF USE, DATA,
*  OR PROFITS) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
*  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
*  THE POSSIBILITY OF SUCH DAMAGE.
*/
/*
 *
 * @author Giulio Ministeri <minister@dei.unipd.it>
 */


#define PC_TEST

#include <inttypes.h>
typedef uint8_t error_t;
/*typedef unsigned char uint8_t;*/
/*typedef unsigned short uint16_t;*/
/*typedef short int16_t*/
/*typedef unsigned int uint32_t;*/
/*typedef int int32_t;*/

#define CACHE
#define REM

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "memory_plain_firstfit.c"
#include <time.h>

#define NUM_TEST 100000
#define MAX_ALLOC 100
#define MAX_HREALLOC LAYER_COAP



int main (void)	{
	int i = 0;
	memory_id_t mem_id[20];
	memory_size_t sizes[20];
	int idx = 0;	
	int op, tempidx;
	memory_size_t size;
	unsigned char* p;
	int n;
	
// calcolo tempo di esecuzione
	clock_t start, end;
	double total, perops;
	
	
	mem_init();
	
	start = clock();
	
	for (i=0; i<=NUM_TEST; i++)	{
			// choose operation	
					//0: alloc   
					//1: hrealloc+
					//2: write
					//3:hrealloc -
					//4: write
					//5: free
					
		op = rand() % 6;
		switch (op)	{
		case 0:
/*			printf("tento alloc...\n");*/
			size = rand() % MAX_ALLOC;
			if (idx < 20)	{
				mem_id[idx] = mem_alloc(size, LAYER_COAP);
				if (mem_id[idx] == 0)	
					printf("alloc non riuscito\n");
				else	{
					printf("alloc ok id %d %d\n", mem_id[idx], size);	
					sizes[idx] = size;
					idx++;
				}
			}
				break;
		case 1:
			if (idx == 0)
				break;
			
/*			printf("tento hrealloc+...\n");	*/
			tempidx = rand() % idx;
			size = rand() % MAX_HREALLOC;
			if (mem_hrealloc(mem_id[tempidx], size) != 0)
				printf ("hrealloc fail\n");
			else	{
				printf ("hrealloc ok id %d %d\n", mem_id[tempidx], size);
				sizes[tempidx] += size;
			}
				
				break;
				
		case 3:
			if (idx == 0)
				break;
			
/*			printf("tento hrealloc-...\n");		*/
			tempidx = rand() % idx;
			p = mem_id2p (mem_id[tempidx], &size);
			if (size <= 1)
				break;
				
			size = -( rand() % size);
			if (mem_hrealloc(mem_id[tempidx], size) != 0)
				printf ("hrealloc fail\n");
			else	{
				printf ("hrealloc ok id %d %d\n", mem_id[tempidx], size);
				sizes[tempidx] += size;
			}
			
				break;
				
		case 2: case 4:
			if (idx == 0)
				break;
			
/*			printf("tento write...\n");	*/
			tempidx = rand() % idx;
			p = mem_id2p (mem_id[tempidx], &size);
			if (size == 0)
				break;
			
			unsigned char byte = (unsigned char)(rand());
			memset (p, byte, size);
			printf ("writing... id %d %x\n", mem_id[tempidx], byte);
				break;
				
		case 5:	
			if (idx == 0)
				break;
			
/*			printf("tento free...\n");		*/
			tempidx = rand() % idx;
			if (mem_free (mem_id[tempidx]) == 0)
				printf("free id %d\n", mem_id[tempidx]);
			else
				printf("free id %d fail\n", mem_id[tempidx]);
				
			for (n=tempidx; n<idx; n++)	{
				mem_id[n] = mem_id[n+1];
				sizes[n] = sizes[n+1];
			}
			
			idx--;
				break;				
		}
/*		mem_dump();*/
/*		sleep (5);*/
	}
	
	end = clock();
	
	total = (double)(end - start)/CLOCKS_PER_SEC * 1000;
	perops = total / NUM_TEST * 1000;
	
	mem_dump();		
	printf ("our dump:\n");
	for (i=0; i<idx; i++)	
		printf("buffer id %d, size %d\n", mem_id[i], sizes[i]);		
	
	printf("Total millisec %f, usec per ops %f\n", total, perops);
	return 0;
}
